* VMx_VMin
*** Program for writing the interval of light change into Vmx and Vmin
*   to THE BRIGTH STARS CATALOGUE medium dBase version (b5_cd.dbf)
*   from its Rem-file b5_srm.dbf

set proce to Vmx_vmin
public lim_unkn,Vpos,VMin_st,vmx_st
sele c
use b5_cd
set filte to var<>'         ' .and. r<>' '
sele b
use b5r_srm inde b5r_srm
SecRun=.F.
? 'Writing variable star limits into VMx and VMin of b5_cd from b5r_srm.'
do All_var
set filte to var<>'         ' .and. r<>' ' .and. (vmin='    ' .or. vmin='?')
sele b
use b5r_rem 
inde on hr to b5r_rem
SecRun=.T.
? 'Trying that once more with unwrapped remarks (from b5r_rem).'
do All_var
sele b
use
sele c
use
sele a
use

return

procedure All_var
sele c
go top
HRLim=0
do while .not. eof()
 lim_unkn=.T.
 hrnum=hr
 sele b
 seek hrnum
 do while hr=hrnum .and. lim_unkn
  if type='VAR'
   txt=trim(text)
   sele c
   do tryV
   do while lim_unkn .and. Vpos>0 .and. Vpos<len(txt)-7
     txt= subst(txt,Vpos+1)
     do tryV
   enddo
   if lim_unkn .and. 'Delta Sct'$b->text
    repla VMx with 'Del', VMin with iif('Sct?'$b->text,'Sct?','Sct')
    lim_unkn=.F.
   endif
   sele b
  endif
  skip
 enddo
 if SecRun .and. (.not. lim_unkn)
  ? 'Star ',HRnum,' faintness limits written.'
 endif
 sele c
 skip
 if HR>HRLim
  ? '  star',HR,' finished'
  HRLim=HRLim+500
 endif
enddo
return


procedure tryV
Vpos=at('V',Upper(txt))
if Vpos>7
 taux=subst(txt,Vpos-7,7)
 Bpos=at('-',taux)
 if Bpos>0              && 'M.MM - mm.mmV' structure is attempted
  if Bpos<7
   taux=ltrim(subst(taux,Bpos+1))   && Vmin
  else
   taux=''
  endif
  Sp_p=at('.',taux)
  ltaux=len(taux)
  if ltaux>0
   do Fill_VMin
   if Vpos+Bpos-14 > 0
    taux=subst(txt,Vpos+Bpos-14,5)
   else
    taux=left(txt,5)                  && Vmx
   endif 
   Sp_p=at(' ',taux)
   if Sp_p>0 .and. Sp_p<4
    taux=subst(taux,Sp_p+1)
   endif
   if right(taux,1)='-'
    taux=left(taux,len(taux)-1)
   endif
   taux=ltrim(taux)       && clearing rest of doublespace
   Sp_p=at('.',taux)
   VMx_st=' '
   if Sp_p=2
    VMx_st=left(taux,1)+subst(taux,3)
   else
    if Sp_p=1
     VMx_st='0'+subst(taux,2)
    else
     if Sp_p=0 .and. len(taux)=1
      VMx_st=taux
     endif
    endif
   endif
   Vmx_st=trim(Vmx_st)
   if len(VMx_st)=4            && rounding mmag to cmag  (case 'm.mmm')
    VMx_st=str(val(VMx_st)/10,3)
   endif
   repla VMx with VMx_st
   Unclear=.F.
   if V<>'   '     && skipping comparison of faintnesses for novae
    Toler=iif(VS=' ',1,iif(VS='H',4,2))
    if  Vmx=' ' .or. Vmin>'9'
     Unclear=.T.
    else     && numbers in both Vmx and VMin
     if right(V,1)=' '
      VVal=val(left(V,3))
      if VVal<val(left(Vmx,2))-2*Toler .or. VVal>val(left(Vmin,3))+2*Toler
       Unclear=.T.
      endif
     else    && last digit present in V
      VVal=val(V)
      if right(VMx,1)=' '
       Unclear=VVal<10*val(left(Vmx,2))-20*Toler
      else
       Unclear=VVal<val(Vmx)-10*Toler
      endif
      if right(VMin,1)=' '
       Unclear=VVal>10*val(left(Vmin,3))+20*Toler
      else
       Unclear=VVal>val(Vmin)+10*Toler
      endif
     endif   && of last digit present in V
    endif  && of numbers in both Vmx and VMin
   endif  && of V known (not an old nova)
   if Unclear
    repla Vmx with '   ', Vmin with '?'
   else
    lim_unkn=.F.
   endif
  endif  && of Len(taux)>0
 else               && Bpos=0, Amp m.mmV is attempted
  if 'AMP'$Upper(left(txt,Vpos))
   Sp_p=at(' ',taux)
   if Sp_p>0
    taux=ltrim(subst(taux,Sp_p))
    Sp_p=at('.',taux)
    ltaux=len(taux)
    if ltaux>0
     do Fill_VMin
    else
     VMin_st='?'
    endif
   else
    VMin_st='?'
   endif
   if VMin_st<>'?'
    repla Vmx with 'Amp'
    lim_unkn=.F.
   endif
  endif
 endif  && of Bpos>0
endif  && of Vpos>7
return

procedure fill_VMin
   if Sp_p>0
    if Sp_p<4
     VMin_st=Space(3-Sp_p)+left(taux,Sp_p-1)+subst(taux,Sp_p+1)
     if len(Vmin_st)=5            && rounding mmag to cmag  (case 'm.mmmV')
      VMin_st=str(val(VMin_st)/10,4)
      if VMin_st='   '
       VMin_st=' 00'+right(VMin_st,1)
      else
       if VMin_st='  '
         VMin_st=' 0'+right(VMin_st,2)
       endif
      endif
     endif
    else
     VMin_st='?'
    endif
   else
     VMin_St=iif(ltaux=1,' ','')+taux
   endif
   if val(VMin_st)=0
    repla Vmin with '?'
   else
    repla VMin with VMin_st
   endif
 return
